## libpng1.6 1.6.20

=== CMakeLists.txt ===
# CMakeLists.txt

# Copyright (C) 2007-2015 Glenn Randers-Pehrson

# This code is released under the libpng license.
# For conditions of distribution and use, see the disclaimer
# and license in png.h

cmake_minimum_required(VERSION 2.4.4)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

set(CMAKE_CONFIGURATION_TYPES "Release;Debug;MinSizeRel;RelWithDebInfo")

project(libpng C)
enable_testing()

set(PNGLIB_MAJOR 1)
set(PNGLIB_MINOR 6)
set(PNGLIB_RELEASE 20)
set(PNGLIB_NAME libpng${PNGLIB_MAJOR}${PNGLIB_MINOR})
set(PNGLIB_VERSION ${PNGLIB_MAJOR}.${PNGLIB_MINOR}.${PNGLIB_RELEASE})

# needed packages
find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIR})

if(NOT WIN32)
  find_library(M_LIBRARY
    NAMES m
    PATHS /usr/lib /usr/local/lib
  )
  if(NOT M_LIBRARY)
    message(STATUS "math lib 'libm' not found; floating point support disabled")
  endif()
else()
  # not needed on windows
  set(M_LIBRARY "")
endif()

# COMMAND LINE OPTIONS
option(PNG_SHARED "Build shared lib" ON)
option(PNG_STATIC "Build static lib" ON)
option(PNG_TESTS  "Build libpng tests" ON)

# Many more configuration options could be added here
option(PNG_FRAMEWORK "Build OS X framework" OFF)
option(PNG_DEBUG     "Build with debug output" OFF)
option(PNGARG        "Disable ANSI-C prototypes" OFF)

# SET LIBNAME
set(PNG_LIB_NAME png${PNGLIB_MAJOR}${PNGLIB_MINOR})

# to distinguish between debug and release lib
set(CMAKE_DEBUG_POSTFIX "d")

# Use the prebuilt pnglibconf.h file from the scripts folder
# TODO: fix this by building with awk; without this no cmake build can be
# configured directly (to do so indirectly use your local awk to build a
# pnglibconf.h in the build directory.)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.h.prebuilt
               ${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# OUR SOURCES
set(libpng_public_hdrs
  png.h
  pngconf.h
  ${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h
)
set(libpng_sources
  ${libpng_public_hdrs}
  pngdebug.h
  pnginfo.h
  pngpriv.h
  pngstruct.h
  png.c
  pngerror.c
  pngget.c
  pngmem.c
  pngpread.c
  pngread.c
  pngrio.c
  pngrtran.c
  pngrutil.c
  pngset.c
  pngtrans.c
  pngwio.c
  pngwrite.c
  pngwtran.c
  pngwutil.c
)
set(pngtest_sources
  pngtest.c
)
set(pngvalid_sources
  contrib/libtests/pngvalid.c
)
set(pngstest_sources
  contrib/libtests/pngstest.c
)
# SOME NEEDED DEFINITIONS

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
endif(MSVC)

if(PNG_DEBUG)
  add_definitions(-DPNG_DEBUG)
endif()

# NOW BUILD OUR TARGET
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${ZLIB_INCLUDE_DIR})

unset(PNG_LIB_TARGETS)

if(PNG_SHARED)
  add_library(${PNG_LIB_NAME} SHARED ${libpng_sources})
  set(PNG_LIB_TARGETS ${PNG_LIB_NAME})
  if(MSVC)
    # msvc does not append 'lib' - do it here to have consistent name
    set_target_properties(${PNG_LIB_NAME} PROPERTIES PREFIX "lib")
    set_target_properties(${PNG_LIB_NAME} PROPERTIES IMPORT_PREFIX "lib")
  endif()
  target_link_libraries(${PNG_LIB_NAME} ${ZLIB_LIBRARY} ${M_LIBRARY})
endif()

if(PNG_STATIC)
  # does not work without changing name
  set(PNG_LIB_NAME_STATIC ${PNG_LIB_NAME}_static)
  add_library(${PNG_LIB_NAME_STATIC} STATIC ${libpng_sources})
  list(APPEND PNG_LIB_TARGETS ${PNG_LIB_NAME_STATIC})
  if(MSVC)
    # msvc does not append 'lib' - do it here to have consistent name
    set_target_properties(${PNG_LIB_NAME_STATIC} PROPERTIES PREFIX "lib")
  endif()
  target_link_libraries(${PNG_LIB_NAME_STATIC} ${ZLIB_LIBRARY} ${M_LIBRARY})
endif()

if(PNG_FRAMEWORK)
  set(PNG_LIB_NAME_FRAMEWORK ${PNG_LIB_NAME}_framework)
  add_library(${PNG_LIB_NAME_FRAMEWORK} SHARED ${libpng_sources})
  list(APPEND PNG_LIB_TARGETS ${PNG_LIB_NAME_FRAMEWORK})
  set_target_properties(${PNG_LIB_NAME_FRAMEWORK} PROPERTIES
    FRAMEWORK TRUE
    FRAMEWORK_VERSION ${PNGLIB_VERSION}
    MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${PNGLIB_MAJOR}.${PNGLIB_MINOR}
    MACOSX_FRAMEWORK_BUNDLE_VERSION ${PNGLIB_VERSION}
    MACOSX_FRAMEWORK_IDENTIFIER org.libpng.libpng
    XCODE_ATTRIBUTE_INSTALL_PATH "@rpath"
    PUBLIC_HEADER "${libpng_public_hdrs}"
    OUTPUT_NAME png)
  target_link_libraries(${PNG_LIB_NAME_FRAMEWORK} ${ZLIB_LIBRARY} ${M_LIBRARY})
endif()

if(NOT PNG_LIB_TARGETS)
  message(SEND_ERROR
    "No library variant selected to build. "
    "Please enable at least one of the following options: "
    " PNG_STATIC, PNG_SHARED, PNG_FRAMEWORK")
endif()

if(PNG_SHARED AND WIN32)
  set_target_properties(${PNG_LIB_NAME} PROPERTIES DEFINE_SYMBOL PNG_BUILD_DLL)
endif()

if(PNG_TESTS AND PNG_SHARED)
  # does not work with msvc due to png_lib_ver issue
  add_executable(pngtest ${pngtest_sources})
  target_link_libraries(pngtest ${PNG_LIB_NAME})
  add_test(pngtest ./pngtest ${CMAKE_CURRENT_SOURCE_DIR}/pngtest.png)
  #
  add_executable(pngvalid ${pngvalid_sources})
  target_link_libraries(pngvalid ${PNG_LIB_NAME})
  add_test(pngvalid ./pngvalid)
  add_executable(pngstest ${pngstest_sources})
  target_link_libraries(pngstest ${PNG_LIB_NAME})
  add_test(pngstest ./pngstest
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn0g01.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn0g02.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn0g04.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn0g08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn0g16.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn2c08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn2c16.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn3p01.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn3p02.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn3p04.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn3p08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn4a08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn4a16.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn6a08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/basn6a16.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbbn0g01.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbbn0g02.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbbn0g04.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbbn2c16.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbbn3p08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbgn2c16.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbgn3p08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbrn2c08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbwn0g16.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbwn3p08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftbyn3p08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftp0n0g08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftp0n2c08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftp0n3p08.png
    ${CMAKE_CURRENT_SOURCE_DIR}/contrib/pngsuite/ftp1n3p08.png
  )
endif()

# Ensure the CMAKE_LIBRARY_OUTPUT_DIRECTORY is set
IF(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY "lib")
ENDIF(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)

# Set a variable with CMake code which:
# Creates a symlink from src to dest (if possible) or alternatively
# copies if different.
macro(CREATE_SYMLINK SRC_FILE DEST_FILE)
  FILE(REMOVE ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${DEST_FILE})
  if(WIN32 AND NOT CYGWIN AND NOT MSYS)
    ADD_CUSTOM_COMMAND(
        OUTPUT ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${DEST_FILE}   ${CMAKE_CURRENT_BINARY_DIR}/${DEST_FILE}
        COMMAND ${CMAKE_COMMAND} -E copy_if_different  "${SRC_FILE}" ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${DEST_FILE}
        COMMAND ${CMAKE_COMMAND} -E copy_if_different  "${SRC_FILE}" ${CMAKE_CURRENT_BINARY_DIR}/${DEST_FILE}
        DEPENDS ${PNG_LIB_TARGETS}
        )
    ADD_CUSTOM_TARGET(${DEST_FILE}_COPY ALL DEPENDS ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${DEST_FILE})
  else(WIN32 AND NOT CYGWIN AND NOT MSYS)
    get_filename_component(LINK_TARGET "${SRC_FILE}" NAME)
    execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
    execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink "${LINK_TARGET}" ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${DEST_FILE} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink "${LINK_TARGET}" ${DEST_FILE} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  endif(WIN32 AND NOT CYGWIN AND NOT MSYS)
endmacro()

# libpng is a library so default to 'lib'
if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(CMAKE_INSTALL_LIBDIR lib)
endif(NOT DEFINED CMAKE_INSTALL_LIBDIR)

# CREATE PKGCONFIG FILES
# we use the same files like ./configure, so we have to set its vars
# Only do this on Windows for Cygwin - the files don't make much sense outside
# a UNIX look alike
if(NOT WIN32 OR CYGWIN OR MINGW)
  set(prefix      ${CMAKE_INSTALL_PREFIX})
  set(exec_prefix ${CMAKE_INSTALL_PREFIX})
  set(libdir      ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
  set(includedir  ${CMAKE_INSTALL_PREFIX}/include)
  set(LIBS        "-lz -lm")
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libpng.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/${PNGLIB_NAME}.pc @ONLY)
  CREATE_SYMLINK(${PNGLIB_NAME}.pc libpng.pc)

  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libpng-config.in
    ${CMAKE_CURRENT_BINARY_DIR}/${PNGLIB_NAME}-config @ONLY)
  CREATE_SYMLINK(${PNGLIB_NAME}-config libpng-config)
endif(NOT WIN32 OR CYGWIN OR MINGW)

# SET UP LINKS
if(PNG_SHARED)
  set_target_properties(${PNG_LIB_NAME} PROPERTIES
#   VERSION 16.${PNGLIB_RELEASE}.1.6.20
    VERSION 16.${PNGLIB_RELEASE}.0
    SOVERSION 16
    CLEAN_DIRECT_OUTPUT 1)
endif()
if(PNG_STATIC)
  # MSVC doesn't use a different file extension for shared vs. static
  # libs.  We are able to change OUTPUT_NAME to remove the _static
  # for all other platforms.
  if(NOT MSVC)
    set_target_properties(${PNG_LIB_NAME_STATIC} PROPERTIES
      OUTPUT_NAME ${PNG_LIB_NAME}
      CLEAN_DIRECT_OUTPUT 1)
  endif()
endif()

# If CMake > 2.4.x, we set a variable used below to export
# targets to an export file.
# TODO: Use VERSION_GREATER after our cmake_minimum_required >= 2.6.2
if(CMAKE_MAJOR_VERSION GREATER 1 AND CMAKE_MINOR_VERSION GREATER 4)
  set(PNG_EXPORT_RULE EXPORT libpng)
elseif(CMAKE_MAJOR_VERSION GREATER 2) # future proof
  set(PNG_EXPORT_RULE EXPORT libpng)
endif()

# INSTALL
if(NOT SKIP_INSTALL_LIBRARIES AND NOT SKIP_INSTALL_ALL )
  install(TARGETS ${PNG_LIB_TARGETS}
      ${PNG_EXPORT_RULE}
      RUNTIME DESTINATION bin
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR})

  if(PNG_SHARED)
    # Create a symlink for libpng.dll.a => libpng16.dll.a on Cygwin
    if(CYGWIN OR MINGW)
       get_target_property(BUILD_TARGET_LOCATION ${PNG_LIB_NAME} LOCATION_${CMAKE_BUILD_TYPE})
       CREATE_SYMLINK(${BUILD_TARGET_LOCATION} libpng${CMAKE_IMPORT_LIBRARY_SUFFIX})
       install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpng${CMAKE_IMPORT_LIBRARY_SUFFIX}
         DESTINATION ${CMAKE_INSTALL_LIBDIR})
    endif(CYGWIN OR MINGW)

    if(NOT WIN32)
      get_target_property(BUILD_TARGET_LOCATION ${PNG_LIB_NAME} LOCATION_${CMAKE_BUILD_TYPE})
      CREATE_SYMLINK(${BUILD_TARGET_LOCATION} libpng${CMAKE_SHARED_LIBRARY_SUFFIX})
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpng${CMAKE_SHARED_LIBRARY_SUFFIX}
         DESTINATION ${CMAKE_INSTALL_LIBDIR})
    endif(NOT WIN32)
  endif(PNG_SHARED)

  if(PNG_STATIC)
    if(NOT WIN32 OR CYGWIN OR MINGW)
      get_target_property(BUILD_TARGET_LOCATION ${PNG_LIB_NAME_STATIC} LOCATION_${CMAKE_BUILD_TYPE})
      CREATE_SYMLINK(${BUILD_TARGET_LOCATION} libpng${CMAKE_STATIC_LIBRARY_SUFFIX})
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpng${CMAKE_STATIC_LIBRARY_SUFFIX}
         DESTINATION ${CMAKE_INSTALL_LIBDIR})
    endif(NOT WIN32 OR CYGWIN OR MINGW)
 endif()
endif()

if(NOT SKIP_INSTALL_HEADERS AND NOT SKIP_INSTALL_ALL )

=== debian/changelog ===
libpng1.6 (1.6.20-2) experimental; urgency=medium

  [ Tobias Frost ]
  * libpng16-16-udeb should not Conflicts: libpng-12-0.

  [ Anibal Monsalve Salazar ]
  * debhelper compat version is 9.
  * debian/control: libpng16-devtools is "Multi-Arch: same".

 -- Anibal Monsalve Salazar <anibal@debian.org>  Thu, 28 Jan 2016 10:33:54 +0000

libpng1.6 (1.6.20-1.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Preparation for the transition, going to experimental.
  * Make libpng16-dev depend on libpng16-devtools to have libpng-config
    pulled in automatically for reverse dependencies.
  * Provide a so-name neutral devtools package

 -- Tobias Frost <tobi@debian.org>  Sun, 24 Jan 2016 11:26:12 +0100

libpng1.6 (1.6.20-1) experimental; urgency=medium

  * New upstream release.
    Fix CVE-2015-8472.
    Closes: #810074.
  * Use default options to compress.
    Remove debian/source/options.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Thu, 07 Jan 2016 23:35:21 +0000

libpng1.6 (1.6.19-1) experimental; urgency=medium

  * New upstream release.
  * Update lintian-overrides for 1.6.19.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 18 Nov 2015 13:07:21 +0900

libpng1.6 (1.6.16-1) experimental; urgency=medium

  * New upstream release (Closes: #773823)
  * Standards Version is 3.9.6.
  * Update debian/copyright.
    Add infomation of license for other all files.
  * Update lintian-overrides for 1.6.16.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 07 Mar 2015 18:33:32 +0900

libpng1.6 (1.6.10-2) experimental; urgency=low

  * Add libpng16-devtools package.
    Move libpng-config to this package.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 02 Apr 2014 09:16:13 +0900

libpng1.6 (1.6.10-1) experimental; urgency=low

  * New upstream release (Closes: #740585)
    Fixed CVE-2014-0333. 
  * Update overrides files.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 22 Mar 2014 09:58:12 +0900

libpng1.6 (1.6.8-2) experimental; urgency=low

  * Update debian/copyright. (Closes: #735737)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 21 Jan 2014 08:59:56 +0900

libpng1.6 (1.6.8-1) experimental; urgency=low

  * New upstream release.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 15 Jan 2014 13:10:28 +0900

libpng1.6 (1.6.7-1) experimental; urgency=low

  * New upstream release.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 14 Jan 2014 15:21:52 +0900

libpng (1.5.11-1) experimental; urgency=low

  * New upstream release.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 05 Jul 2012 13:18:14 +0900

libpng (1.5.10-3) experimental; urgency=low

  * Remove libpng12-dev binary package. libpng-dev provides and replaces
    libpng12-dev.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sat, 19 May 2012 18:55:25 +1000

libpng (1.5.10-2) experimental; urgency=low

  * Add transition packages libpng3, libpng12-0 and libpng12-dev

 -- Anibal Monsalve Salazar <anibal@debian.org>  Fri, 18 May 2012 10:09:24 +1000

libpng (1.5.10-1) experimental; urgency=high

  * New upstream version 1.5.10
    - Fix CVE-2011-3048 (memory corruption flaw)
      Closes: 667475
  * Standards Version is 3.9.3

 -- Anibal Monsalve Salazar <anibal@debian.org>  Mon, 09 Apr 2012 13:29:39 +1000

libpng (1.5.9-1) experimental; urgency=low

  * New upstream version 1.5.9

    The purpose of this release is to fix the dangerous CVE-2011-3026.
    The libpng patch is different from the one that was distributed
    earlier by Chromium, in that the libpng user limit feature is not
    crippled by the patch.

    Remove 02-660026-CVE-2011-3026.patch

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sun, 19 Feb 2012 12:22:43 +1100

libpng (1.5.8-1) experimental; urgency=high

  * New upstream release.
    Fix a one-byte (stack) buffer-overrun bug in
    png_formatted_warning(), which could lead to crashes (denial of
    service) or, conceivably, execution of hostile code.
    This vulnerability has been assigned ID CVE-2011-3464.
  * Check for both truncation (64-bit platforms) and integer overflow
    Fix CVE-2011-3026
    Add 02-660026-CVE-2011-3026.patch
    Closes: 660026

 -- Anibal Monsalve Salazar <anibal@debian.org>  Thu, 16 Feb 2012 09:18:13 +1100

libpng (1.5.7-2) experimental; urgency=low

  * Fix typo from PPFLAGS to CPPFLAGS.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 09 Jan 2012 21:39:33 +0900

libpng (1.5.7-1) experimental; urgency=low

  * New upstream release.
  * Update debian/rules.
    Enabled hardened build flags. (Closes: #654149)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 09 Jan 2012 21:02:50 +0900

libpng (1.5.6-1) experimental; urgency=low

  * New upstream release.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 07 Nov 2011 12:35:59 +0900

libpng (1.5.5-1) experimental; urgency=low

  * New upstream release.
  * Fix lintian error: udeb-uses-non-gzip-data-tarball.
    Changed option of dh_builddeb for every package.
  * Fix lintian warning: brace-expansion-in-debhelper-config-file.
    Remove brace-expansion from debian/libpng-dev.install.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 26 Oct 2011 12:35:05 +0900

libpng (1.5.4-2) experimental; urgency=low

  * Port Steve Langasek's changes for 1.2.46-1
    - Build for multiarch. Closes: 634151
    - Drop debian/libpng15-15-udeb.dirs, which just adds a pointless empty
      directory to the udeb
  * Update debian/docs and debian/libpng15-15.docs
  * Add debian/libpng15-15.doc-base
  * Build-Depend on autotools-dev

 -- Anibal Monsalve Salazar <anibal@debian.org>  Tue, 19 Jul 2011 00:49:57 +1000

libpng (1.2.46-2) unstable; urgency=low

  [ Steve Langasek ]
  * Build for multiarch.  Requires converting libpng3 from Arch: all to
    Arch: any. Closes: 634151
  * Drop debian/libpng12-0-udeb.dirs, which just adds a pointless empty
    directory to the udeb.

  [ Anibal Monsalve Salazar ]
  * Fix doc-base file
    Closes: 633944, 633957, 634120
  * Pass "-Zbzip2 -z9" to dpkg-deb



=== debian/control ===
Source: libpng1.6
Section: libs
Priority: optional
Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper (>= 9), zlib1g-dev, mawk, autotools-dev
Standards-Version: 3.9.6
Homepage: http://libpng.org/pub/png/libpng.html

Package: libpng16-16
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: mzscheme (<= 1:209-5), pngcrush (<= 1.5.10-2), pngmeta (<= 1.11-3), qemacs (<= 0.3.1-5), povray-3.5 (<= 3.5.0c-10)
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: PNG library - runtime (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package contains the runtime library files needed to run software
 using libpng.

Package: libpng16-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libpng16-16 (= ${binary:Version}), zlib1g-dev, libpng16-devtools (= ${binary:Version})
Conflicts: libpng12-dev, libpng12-0-dev, libpng3-dev, libpng2-dev
Replaces: libpng12-dev, libpng12-0-dev, libpng3-dev, libpng2-dev
#Provides: libpng-dev
Recommends: libpng16-tools
Multi-Arch: same
Description: PNG library - development (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package contains the header and development files needed to build
 programs and packages using libpng.

Package: libpng16-devtools
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libpng16-dev (= ${binary:Version})
Provides: libpng-devtools
Conflicts: libpng12-dev, libpng12-0-dev, libpng3-dev, libpng2-dev, libpng16-tools (<= 1.6.10-1)
Replaces: libpng12-dev, libpng12-0-dev, libpng3-dev, libpng2-dev
Description: PNG library - tools (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package contains tools needed to develop software using libpng.

Package: libpng16-tools
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpng16-16 (= ${binary:Version})
# Provides: libpng-tools
Conflicts: libpng12-dev, libpng12-0-dev, libpng3-dev, libpng2-dev
Replaces: libpng12-dev, libpng12-0-dev, libpng3-dev, libpng2-dev
Description: PNG library - tools (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package contains a program to interact with libpng from the
 command line.

Package: libpng16-16-udeb
Package-Type: udeb
Section: debian-installer
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: PNG library - minimal runtime library (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package provides the minimal libpng runtime library needed for
 the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = `dpkg-buildflags --get CFLAGS`
CFLAGS += -Wall
LDFLAGS = `dpkg-buildflags --get LDFLAGS`
LDFLAGS += "-Wl,-z,defs"
CPPFLAGS = `dpkg-buildflags --get CPPFLAGS`

config.status: configure
	dh_testdir
	cp -f /usr/share/misc/config.sub /usr/share/misc/config.guess .
	#./autogen.sh
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr --mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)"

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:  config.status
	dh_testdir
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean pngtest-static

install: build
	dh_testdir
	dh_testroot
	dh_prep
	set -e; for file in libpng16-16.install libpng16-16.links libpng16-dev.links ; \
	do \
		sed -e"s,\$${DEB_HOST_MULTIARCH},${DEB_HOST_MULTIARCH},g" \
			debian/$${file}.in > debian/$$file; \
	done
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	gcc -Wall -g -O2 -c -o pngtest.o pngtest.c
	gcc -o pngtest -Wall -g -O2 pngtest.o -L.libs -lpng16
	gcc -o pngtest-static -Wall -g -O2  pngtest.o .libs/libpng16.a -lz -lm
	LD_LIBRARY_PATH=".libs:" ./pngtest
	./pngtest-static
endif

binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_link -i
	dh_installchangelogs CHANGES -i
	dh_installdocs -i
	dh_install --sourcedir=debian/tmp -i
	dh_installman -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_link -a
	dh_installchangelogs -a CHANGES
	dh_installdocs -a
	dh_installexamples -plibpng16-dev example.c pngtest.c pngtest.png
	dh_install --sourcedir=debian/tmp -a
	dh_installman -a
	dh_lintian -plibpng16-16 -a
	# This does not work....
	# dh_lintian -plibpng16-16-udeb -a
	install -d debian/libpng16-16-udeb/usr/share/lintian/overrides
	install -p -m644 debian/libpng16-16-udeb.lintian-overrides \
		debian/libpng16-16-udeb/usr/share/lintian/overrides/libpng16-16-udeb
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs --add-udeb=libpng16-16-udeb -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## libpng1.6 1.6.25

=== CMakeLists.txt ===
# CMakeLists.txt

# Copyright (C) 2007,2009-2016 Glenn Randers-Pehrson
# Written by Christian Ehrlicher, 2007
# Revised by Roger Lowman, 2009-2010
# Revised by Clifford Yapp, 2011-2012
# Revised by Roger Leigh, 2016

# This code is released under the libpng license.
# For conditions of distribution and use, see the disclaimer
# and license in png.h

cmake_minimum_required(VERSION 2.8.3)
cmake_policy(VERSION 2.8.3)

# Set MacOSX @rpath usage globally.
if (POLICY CMP0020)
  cmake_policy(SET CMP0020 NEW)
endif(POLICY CMP0020)
if (POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif(POLICY CMP0042)
# Use new variable expansion policy.
if (POLICY CMP0053)
  cmake_policy(SET CMP0053 NEW)
endif(POLICY CMP0053)
if (POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif(POLICY CMP0054)

set(CMAKE_CONFIGURATION_TYPES "Release;Debug;MinSizeRel;RelWithDebInfo")

project(libpng C)
enable_testing()

set(PNGLIB_MAJOR 1)
set(PNGLIB_MINOR 6)
set(PNGLIB_RELEASE 25)
set(PNGLIB_NAME libpng${PNGLIB_MAJOR}${PNGLIB_MINOR})
set(PNGLIB_VERSION ${PNGLIB_MAJOR}.${PNGLIB_MINOR}.${PNGLIB_RELEASE})

# needed packages
find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIR})

if(NOT WIN32)
  find_library(M_LIBRARY
    NAMES m
    PATHS /usr/lib /usr/local/lib
  )
  if(NOT M_LIBRARY)
    message(STATUS "math lib 'libm' not found; floating point support disabled")
  endif()
else()
  # not needed on windows
  set(M_LIBRARY "")
endif()

# COMMAND LINE OPTIONS
option(PNG_SHARED "Build shared lib" ON)
option(PNG_STATIC "Build static lib" ON)
option(PNG_TESTS  "Build libpng tests" ON)

# Many more configuration options could be added here
option(PNG_FRAMEWORK "Build OS X framework" OFF)
option(PNG_DEBUG     "Build with debug output" OFF)
option(PNGARG        "Disable ANSI-C prototypes" OFF)

set(PNG_PREFIX "" CACHE STRING "Prefix to add to the API function names")
set(DFA_XTRA "" CACHE FILEPATH "File containing extra configuration settings")

# SET LIBNAME
set(PNG_LIB_NAME png${PNGLIB_MAJOR}${PNGLIB_MINOR})

# to distinguish between debug and release lib
set(CMAKE_DEBUG_POSTFIX "d")

include(CheckCSourceCompiles)
option(ld-version-script "Enable linker version script" ON)
if(ld-version-script AND NOT APPLE)
  # Check if LD supports linker scripts.
  file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/conftest.map" "VERS_1 {
        global: sym;
        local: *;
};

VERS_2 {
        global: sym2;
                main;
} VERS_1;
")
  set(CMAKE_REQUIRED_FLAGS_SAVE ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS} "-Wl,--version-script='${CMAKE_CURRENT_BINARY_DIR}/conftest.map'")
  check_c_source_compiles("void sym(void) {}
void sym2(void) {}
int main(void) {return 0;}
" HAVE_LD_VERSION_SCRIPT)
  if(NOT HAVE_LD_VERSION_SCRIPT)
    set(CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS_SAVE} "-Wl,-M -Wl,${CMAKE_CURRENT_BINARY_DIR}/conftest.map")
  check_c_source_compiles("void sym(void) {}
void sym2(void) {}
int main(void) {return 0;}
" HAVE_SOLARIS_LD_VERSION_SCRIPT)
  endif()
  set(CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS_SAVE})
  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/conftest.map")
endif()

# Find symbol prefix.  Likely obsolete and unnecessary with recent
# toolchains (it's not done in many other projects).
function(symbol_prefix)
  set(SYMBOL_PREFIX)

  execute_process(COMMAND "${CMAKE_C_COMPILER}" "-E" "-"
                  INPUT_FILE /dev/null
                  OUTPUT_VARIABLE OUT
                  RESULT_VARIABLE STATUS)

  if(CPP_FAIL)
    message(WARNING "Failed to run the C preprocessor")
  endif()

  string(REPLACE "\n" ";" OUT "${OUT}")
  foreach(line ${OUT})
    string(REGEX MATCH "^PREFIX=" found_match "${line}")
    if(found_match)
      STRING(REGEX REPLACE "^PREFIX=(.*\)" "\\1" prefix "${line}")
      string(REGEX MATCH "__USER_LABEL_PREFIX__" found_match "${prefix}")
      if(found_match)
        STRING(REGEX REPLACE "(.*)__USER_LABEL_PREFIX__(.*)" "\\1\\2" prefix "${prefix}")
      endif()
      set(SYMBOL_PREFIX "${prefix}")
    endif()
  endforeach()

    message(STATUS "Symbol prefix: ${SYMBOL_PREFIX}")
    set(SYMBOL_PREFIX "${SYMBOL_PREFIX}" PARENT_SCOPE)
endfunction()

if(UNIX)
  symbol_prefix()
endif()

find_program(AWK NAMES gawk awk)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(NOT AWK)
  # No awk available to generate sources; use pre-built pnglibconf.h
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.h.prebuilt
                 ${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h)
  add_custom_target(genfiles) # Dummy
else()
  include(CMakeParseArguments)
  # Generate .chk from .out with awk
  # generate_chk(INPUT inputfile OUTPUT outputfile [DEPENDS dep1 [dep2...]])
  function(generate_chk)
    set(options)
    set(oneValueArgs INPUT OUTPUT)
    set(multiValueArgs DEPENDS)
    cmake_parse_arguments(_GC "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
    if (NOT _GC_INPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_out requires input.")
    endif()
    if (NOT _GC_OUTPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_out requires output.")
    endif()

    add_custom_command(OUTPUT "${_GC_OUTPUT}"
                       COMMAND "${CMAKE_COMMAND}"
                               "-DINPUT=${_GC_INPUT}"
                               "-DOUTPUT=${_GC_OUTPUT}"
                               -P "${CMAKE_CURRENT_BINARY_DIR}/scripts/genchk.cmake"
                       DEPENDS "${_GC_INPUT}" ${_GC_DEPENDS}
                       WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  endfunction()

  # Generate .out from .c with awk
  # generate_out(INPUT inputfile OUTPUT outputfile [DEPENDS dep1 [dep2...]])
  function(generate_out)
    set(options)
    set(oneValueArgs INPUT OUTPUT)
    set(multiValueArgs DEPENDS)
    cmake_parse_arguments(_GO "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
    if (NOT _GO_INPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_out requires input.")
    endif()
    if (NOT _GO_OUTPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_out requires output.")
    endif()

    add_custom_command(OUTPUT "${_GO_OUTPUT}"
                       COMMAND "${CMAKE_COMMAND}"
                               "-DINPUT=${_GO_INPUT}"
                               "-DOUTPUT=${_GO_OUTPUT}"
                               -P "${CMAKE_CURRENT_BINARY_DIR}/scripts/genout.cmake"
                       DEPENDS "${_GO_INPUT}" ${_GO_DEPENDS}
                       WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  endfunction()

  # Generate specific source file with awk
  # generate_source(OUTPUT outputfile [DEPENDS dep1 [dep2...]])
  function(generate_source)
    set(options)
    set(oneValueArgs OUTPUT)
    set(multiValueArgs DEPENDS)
    cmake_parse_arguments(_GSO "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
    if (NOT _GSO_OUTPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_source requires output.")
    endif()

    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_GSO_OUTPUT}"
                       COMMAND "${CMAKE_COMMAND}"
                               "-DOUTPUT=${_GSO_OUTPUT}"
                               -P "${CMAKE_CURRENT_BINARY_DIR}/scripts/gensrc.cmake"
                       DEPENDS ${_GSO_DEPENDS}
                       WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  endfunction()

  # Copy file
  function(generate_copy source destination)
    add_custom_command(OUTPUT "${destination}"
                       COMMAND "${CMAKE_COMMAND}" -E remove "${destination}"
                       COMMAND "${CMAKE_COMMAND}" -E copy "${source}"
                                                          "${destination}"
                       DEPENDS "${source}")
  endfunction()

  # Generate scripts/pnglibconf.h
  generate_source(OUTPUT "scripts/pnglibconf.c"
                  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.dfa"
                          "${CMAKE_CURRENT_SOURCE_DIR}/scripts/options.awk"
                          "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h")

  # Generate pnglibconf.c
  generate_source(OUTPUT "pnglibconf.c"
                  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.dfa"
                          "${CMAKE_CURRENT_SOURCE_DIR}/scripts/options.awk"
                          "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h")

  if(PNG_PREFIX)
    set(PNGLIBCONF_H_EXTRA_DEPENDS
        "${CMAKE_CURRENT_BINARY_DIR}/scripts/prefix.out"
        "${CMAKE_CURRENT_SOURCE_DIR}/scripts/macro.lst")
    set(PNGPREFIX_H_EXTRA_DEPENDS
        "${CMAKE_CURRENT_BINARY_DIR}/scripts/intprefix.out")
  endif()

  generate_out(INPUT "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.out")

  # Generate pnglibconf.h
  generate_source(OUTPUT "pnglibconf.h"
                  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.out"
                          ${PNGLIBCONF_H_EXTRA_DEPENDS})

  generate_out(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/scripts/intprefix.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/intprefix.out"
               DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h")

  generate_out(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/scripts/prefix.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/prefix.out"
               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/png.h"
                       "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h"
                       "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.out")

  # Generate pngprefix.h
  generate_source(OUTPUT "pngprefix.h"
                  DEPENDS ${PNGPREFIX_H_EXTRA_DEPENDS})

  generate_out(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/scripts/sym.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/sym.out"
               DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h")

  generate_out(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/scripts/symbols.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.out"
               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/png.h"
                       "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h"
                       "${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.h.prebuilt")

  generate_out(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/scripts/vers.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/vers.out"
               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/png.h"
                       "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h"
                       "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h")

  generate_chk(INPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.out"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.chk"
               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/checksym.awk"
                       "${CMAKE_CURRENT_SOURCE_DIR}/scripts/symbols.def")

  add_custom_target(symbol-check DEPENDS
                    "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.chk")

  generate_copy("${CMAKE_CURRENT_BINARY_DIR}/scripts/sym.out"
                "${CMAKE_CURRENT_BINARY_DIR}/libpng.sym")
  generate_copy("${CMAKE_CURRENT_BINARY_DIR}/scripts/vers.out"
                "${CMAKE_CURRENT_BINARY_DIR}/libpng.vers")

  add_custom_target(genvers DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/libpng.vers")
  add_custom_target(gensym DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/libpng.sym")

  add_custom_target("genprebuilt"
                    COMMAND "${CMAKE_COMMAND}"
                            "-DOUTPUT=scripts/pnglibconf.h.prebuilt"
                            -P "${CMAKE_CURRENT_BINARY_DIR}/scripts/gensrc.cmake"
                    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

  # A single target handles generation of all generated files.  If
  # they are dependend upon separately by multiple targets, this
  # confuses parallel make (it would require a separate top-level
  # target for each file to track the dependencies properly).
  add_custom_target(genfiles DEPENDS
    "${CMAKE_CURRENT_BINARY_DIR}/libpng.sym"
    "${CMAKE_CURRENT_BINARY_DIR}/libpng.vers"

=== debian/control ===
Source: libpng1.6
Section: libs
Priority: optional
Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>,
           Gianfranco Costamagna <locutusofborg@debian.org>,
           Tobias Frost <tobi@debian.org>
Build-Depends: debhelper (>= 9), zlib1g-dev, mawk, dh-autoreconf
Standards-Version: 3.9.8
VCS-Git: https://anonscm.debian.org/git/collab-maint/libpng1.6.git
VCS-Browser: https://anonscm.debian.org/cgit/collab-maint/libpng1.6.git
Homepage: http://libpng.org/pub/png/libpng.html

Package: libpng16-16
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: PNG library - runtime (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package contains the runtime library files needed to run software
 using libpng.

Package: libpng-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libpng16-16 (= ${binary:Version}), zlib1g-dev
Conflicts: libpng12-0-dev, libpng12-dev, libpng2-dev, libpng3-dev
Breaks: libpng16-dev (<< 1.6.20-3), libpng16-devtools (<< 1.6.21-1)
Replaces: libpng16-dev (<< 1.6.20-3), libpng16-devtools (<< 1.6.21-1)
Recommends: libpng-tools
Description: PNG library - development (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package contains the header and development files needed to build
 programs and packages using libpng.

Package: libpng-tools
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpng16-16 (= ${binary:Version})
Breaks: libpng16-tools (<< 1.6.21-1)
Replaces: libpng16-tools (<< 1.6.21-1)
Description: PNG library - tools (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package contains a program to interact with libpng from the
 command line.

Package: libpng16-16-udeb
Package-Type: udeb
Section: debian-installer
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: PNG library - minimal runtime library (version 1.6)
 libpng is a library implementing an interface for reading and writing
 PNG (Portable Network Graphics) format files.
 .
 This package provides the minimal libpng runtime library needed for
 the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS   := hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND   := $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND := $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_LDFLAGS_MAINT_APPEND  := -Wl,--as-needed

%:
	dh $@ --parallel --with autoreconf

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

override_dh_auto_test:
	LD_LIBRARY_PATH=".libs:" dh_auto_test
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	gcc -Wall -g -O2 -c -o pngtest.o pngtest.c
	gcc -o pngtest-static -Wall -g -O2  pngtest.o .libs/libpng16.a -lz -lm
	./pngtest-static
endif

override_dh_installexamples:
	dh_installexamples -plibpng16-dev example.c pngtest.c pngtest.png

override_dh_makeshlibs:
	dh_makeshlibs --add-udeb=libpng16-16-udeb -a

## libpng1.6 1.6.28

=== debian/changelog ===
libpng1.6 (1.6.28-1+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Call png_image_free_function without guarding it with png_safe_execute
    (CVE-2019-7317) (Closes: #921355)

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 18 Apr 2019 22:12:35 +0200

libpng1.6 (1.6.28-1) unstable; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 09 Jan 2017 19:50:31 +0100

libpng1.6 (1.6.27-1) unstable; urgency=medium

  * New upstream release (Closes: #849799)
    - Fix for CVE-2016-10087

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 31 Dec 2016 08:51:32 +0100

libpng1.6 (1.6.26-6) unstable; urgency=medium

  * Enable pie in Debian, disable it in Ubuntu.
    - thanks pochu :)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 08 Dec 2016 17:03:30 +0100

libpng1.6 (1.6.26-5) unstable; urgency=medium

  * Revert cmake switch, failing on arm64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 07 Dec 2016 08:41:24 +0100

libpng1.6 (1.6.26-4) unstable; urgency=low

   * Upload to unstable.
   * Disable pie where Ubuntu has not defaulted yet.
     (armhf, arm64, powerpc)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 15 Nov 2016 20:50:40 +0100

libpng1.6 (1.6.26-3) experimental; urgency=medium

  * Switch to cmake.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 15 Nov 2016 20:50:40 +0100

libpng1.6 (1.6.26-2) unstable; urgency=medium

  * Enable full hardening (+pie) (Closes: #844429)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 15 Nov 2016 18:10:16 +0100

libpng1.6 (1.6.26-1) unstable; urgency=low

  * New upstream release.
  * Switch to compat level 10
    - Drop autoreconf/parallel, automatically injected

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 24 Oct 2016 19:36:32 +0200

libpng1.6 (1.6.25-2) unstable; urgency=medium

  * Mark the -tools package Multi-Arch: foreign.
    (Closes: #840446).
    Thanks Francois Gourget for the bug report!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 11 Oct 2016 19:13:50 +0200

libpng1.6 (1.6.25-1) unstable; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 06 Sep 2016 12:29:51 +0200

libpng1.6 (1.6.24-2) unstable; urgency=medium

  * Stop providing pngcp, because a tool with the same
    name is provided by pngtools (Closes: #834119, #834118).
    - Consider re-enabling it if ineeded, but for now the
      tool has no manpage and no help command.
    - An alternative might be to make pngtools and libpng-tools
      conflict each others.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 12 Aug 2016 10:35:50 +0200

libpng1.6 (1.6.24-1) unstable; urgency=medium

  * New upstream release.
    - install also new pngcp tool in libpng-tools package.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Aug 2016 23:14:13 +0200

libpng1.6 (1.6.23-1) unstable; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 15 Jun 2016 16:41:46 +0200

libpng1.6 (1.6.22-1) unstable; urgency=medium

  * New upstream release.
    - drop fix_define_PNG_READ_16_TO_8.patch: upstream
  * Update copyright file.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 05 Jun 2016 23:41:22 +0200

libpng1.6 (1.6.21-5) unstable; urgency=medium

  * d/control: Add VCS-* to repository on collab-maint.
  * Add patch to properly define PNG_READ_16_TO_8_SUPPORTED (Closes: #824014)
  * Add d/gbp.conf to ensure signed tags.

 -- Tobias Frost <tobi@debian.org>  Wed, 11 May 2016 19:30:16 +0200

libpng1.6 (1.6.21-4) unstable; urgency=medium

  * add libpng-config.patch from the old
    src:libpng.
    - disabling multiarch bits in libpng-config has
      the "side-effect" to let us have a Multiarch libpng-dev package.
      Closes: #822297
  * Make the libpng-dev package Multiarch ready.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 23 Apr 2016 09:04:06 +0200

libpng1.6 (1.6.21-3) unstable; urgency=medium

  [ Manuel A. Fernandez Montecelo ]
  * Add hardening flags (excluding PIE. CLoses: #805822)

  [ Gianfranco Costamagna ]
  * Drop useless pre-depends line.

  [ Bart Martens ]
  * Fix watch file

  [ Laurent Bigonville ]
  * Drop useless packages in Replaces field. (Closes: #820887)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 13 Apr 2016 08:49:30 +0200

libpng1.6 (1.6.21-2) unstable; urgency=medium

  * Upload to unstable.
  * Add myself and Tobias to uploaders, as per maintainers
    suggestion.
  * Bump std-version to 3.9.8, no changes required.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Apr 2016 17:26:38 +0200

libpng1.6 (1.6.21-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Add upstream signing key
  * Fix watch file.
  * Update copyright file.
  * Drop libpng16-devtools, useless and merged in libpng-dev.
    (many packages relies on that script for building correctly)
    - breaks + replaces accordingly.
  * Remove multiarch -dev package
  * Rename libpng16-tools to libpng-tools, there is no need of
    strict versioning here.
  * Install upstream changelog.
  * Run upstream testsuite.
  * Remove README.* files, useless now.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 31 Mar 2016 14:43:03 +0200

libpng1.6 (1.6.20-3) experimental; urgency=medium

  * Team upload
  * Move libpng16-dev to libpng-dev, to ease next transitions.
  * Drop conflicts against mzscheme, pngcrush, pngmeta,
    povray-3.5, qemacs, some of them disappeared, some of
    them have later versions already in old-oldstable.
  * Simplify even more the packaging, probably fixing #813288
  * Fix symlinks, and two lintian errors:
    - library-in-root-and-usr
    - old-style-config-script-multiarch-path
      (multiarch: no for libpng16-devtools)
  * Update standard-version to 3.9.7, no changes required.


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS   := hardening=+all
export DEB_CFLAGS_MAINT_APPEND   := $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND := $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_LDFLAGS_MAINT_APPEND  := -Wl,--as-needed
CC?=gcc

%:
	dh $@

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(shell dpkg-vendor --derives-from ubuntu && echo true),true)
ifneq (,$(filter $(DEB_HOST_ARCH), armhf arm64 powerpc))
  export DEB_BUILD_MAINT_OPTIONS   := hardening=+all,-pie
endif
endif

override_dh_auto_test:
	LD_LIBRARY_PATH=".libs:" dh_auto_test
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	$(CC) $(CFLAGS) $(CPPFLAGS) -Wall -g -O2 -c -o pngtest.o pngtest.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o pngtest-static -Wall -g -O2  pngtest.o .libs/libpng16.a -lz -lm
	./pngtest-static
endif

override_dh_installexamples:
	dh_installexamples -plibpng16-dev example.c pngtest.c pngtest.png

override_dh_makeshlibs:
	dh_makeshlibs --add-udeb=libpng16-16-udeb -a

=== debian/watch ===
version=3
opts=uversionmangle=s/_/./g;s/^(\S+-x86\.64)/0.0.$1/;s/^(\S+-i586)/0.0.$1/ \
http://libpng.org/pub/png/libpng.html \
(?:|.*/)libpng(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
